/*	The class of the perfect cube.
 *
 *	The size of the cube is 256x256x256.
 *	It consists of perfect rectangles with size 4x4x16.
 *
 *	Created by :    Bala'zs Gero"fi (kedli@inf.elte.hu)
 *			Ga'bor Bala'zs (bege@inf.elte.hu)       [2003.05.16]
 */

#ifndef PERFCUBE_H
#define PERFCUBE_H

class PerfRect;
class ostream;

class PerfCube
{
  public:
	PerfCube();
	~PerfCube();

	// test the cube whether it is perfect
	bool testing();

	// print the "big" cube to a text file
	void print(ostream &out);

	// print the "big" cube to a tex file
	void printtex(ostream &out);

	int at(int x, int y, int z);

  private:
	PerfRect* cube[64][64][16];	// the cube contains PerfRect objects
};

#endif	/* PERFCUBE_H */

